Skip to main content
POST
/
assets
/
{assetId}
/
blocks
/
operations
Apply block operations
curl --request POST \
  --url https://versuno.ai/api/public/assets/{assetId}/blocks/operations \
  --header 'Authorization: <api-key>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "operations": [
    {
      "op": "turn_into",
      "targetBlockId": "b_35effee2-0c97-463b-9a0a-8973eca1b4da",
      "turnInto": "quote"
    },
    {
      "op": "turn_into",
      "targetBlockId": "b_74f0ee4e-59c3-4593-9ac7-7b0f5ddf359a",
      "turnInto": "heading2"
    }
  ]
}
'
import requests

url = "https://versuno.ai/api/public/assets/{assetId}/blocks/operations"

payload = { "operations": [
        {
            "op": "turn_into",
            "targetBlockId": "b_35effee2-0c97-463b-9a0a-8973eca1b4da",
            "turnInto": "quote"
        },
        {
            "op": "turn_into",
            "targetBlockId": "b_74f0ee4e-59c3-4593-9ac7-7b0f5ddf359a",
            "turnInto": "heading2"
        }
    ] }
headers = {
    "Authorization": "<api-key>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.text)
const options = {
  method: 'POST',
  headers: {Authorization: '<api-key>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    operations: [
      {
        op: 'turn_into',
        targetBlockId: 'b_35effee2-0c97-463b-9a0a-8973eca1b4da',
        turnInto: 'quote'
      },
      {
        op: 'turn_into',
        targetBlockId: 'b_74f0ee4e-59c3-4593-9ac7-7b0f5ddf359a',
        turnInto: 'heading2'
      }
    ]
  })
};

fetch('https://versuno.ai/api/public/assets/{assetId}/blocks/operations', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://versuno.ai/api/public/assets/{assetId}/blocks/operations"

	payload := strings.NewReader("{\n  \"operations\": [\n    {\n      \"op\": \"turn_into\",\n      \"targetBlockId\": \"b_35effee2-0c97-463b-9a0a-8973eca1b4da\",\n      \"turnInto\": \"quote\"\n    },\n    {\n      \"op\": \"turn_into\",\n      \"targetBlockId\": \"b_74f0ee4e-59c3-4593-9ac7-7b0f5ddf359a\",\n      \"turnInto\": \"heading2\"\n    }\n  ]\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<api-key>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(string(body))

}


HttpResponse<String> response = Unirest.post("https://versuno.ai/api/public/assets/{assetId}/blocks/operations")
  .header("Authorization", "<api-key>")
  .header("Content-Type", "application/json")
  .body("{\n  \"operations\": [\n    {\n      \"op\": \"turn_into\",\n      \"targetBlockId\": \"b_35effee2-0c97-463b-9a0a-8973eca1b4da\",\n      \"turnInto\": \"quote\"\n    },\n    {\n      \"op\": \"turn_into\",\n      \"targetBlockId\": \"b_74f0ee4e-59c3-4593-9ac7-7b0f5ddf359a\",\n      \"turnInto\": \"heading2\"\n    }\n  ]\n}")
  .asString();
using RestSharp;


var options = new RestClientOptions("https://versuno.ai/api/public/assets/{assetId}/blocks/operations");
var client = new RestClient(options);
var request = new RestRequest("");
request.AddHeader("Authorization", "<api-key>");
request.AddJsonBody("{\n  \"operations\": [\n    {\n      \"op\": \"turn_into\",\n      \"targetBlockId\": \"b_35effee2-0c97-463b-9a0a-8973eca1b4da\",\n      \"turnInto\": \"quote\"\n    },\n    {\n      \"op\": \"turn_into\",\n      \"targetBlockId\": \"b_74f0ee4e-59c3-4593-9ac7-7b0f5ddf359a\",\n      \"turnInto\": \"heading2\"\n    }\n  ]\n}", false);
var response = await client.PostAsync(request);

Console.WriteLine("{0}", response.Content);
{
  "assetId": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
  "appliedOperations": [
    {
      "op": "<string>",
      "targetBlockId": "<string>",
      "turnInto": "<string>"
    }
  ],
  "contentBlocks": [
    {
      "id": "b_35effee2-0c97-463b-9a0a-8973eca1b4da",
      "type": "paragraph",
      "meta": {},
      "content": "This block was updated",
      "inline": [
        {}
      ],
      "children": "<array>"
    }
  ]
}
{
  "error": "Wrong data: assetType is required"
}
{
  "error": "Invalid API key"
}
{
  "error": "Forbidden"
}
{
  "error": "Not found"
}
{
  "error": "Asset is already in trash"
}
Use this endpoint for structural transforms that rewrite the block tree. Supported command:
  • turn_into (UI parity command with turnInto values from editor options)
Use PATCH /assets/{assetId}/blocks for field updates only (content, inline, meta).

Authorizations

Authorization
string
header
default:Bearer uk_live_your_api_key_here
required

Versuno API key. Must be prefixed with Bearer. Format: Bearer uk_live_...

Path Parameters

assetId
string<uuid>
required

Query Parameters

assetType
enum<string>

Optional type guard. If supplied, it must match the asset's actual type.

Available options:
prompt,
persona,
context,
system_prompt,
skill

Body

application/json
operations
object[]
required
Minimum array length: 1

Response

Operations applied and full updated block tree returned.

assetId
string<uuid>
appliedOperations
object[]
contentBlocks
object[]